class MeuCalendarioHTML extends MeuCalendario
{
    public function __construct($mes, $ano)
    {
        parent::__construct($mes, $ano);
    }

   /**
    * Ajuda a decidir se irá imprimir os dias do mês anterior
    * @param int $indexLoop
    * @return boolean
    */
    private function isAnterior($indexLoop)
    {
        if (is_int($indexLoop)) {
            return (($this->isDiasMesAnterior() == TRUE) && ($this->getDiasDoMes()[$indexLoop] > 25 && $indexLoop < 6)) ? TRUE : FALSE;
        } else {
            throw new Exception("Erro: Valor incorreto indicado como indice de array do calendário: ".$indexLoop);
        }
    }

   /**
    * Ajuda a decidir se irá imprimir os dias do mês seguinte
    * @param int $indexLoop
    * @return boolean
    */
    private function isSeguinte($indexLoop)
    {
        if (is_int($indexLoop)) {
            return (($this->isDiasMesSeguinte() == TRUE) && ($this->getDiasDoMes()[$indexLoop] < 15 && $indexLoop > 27)) ? TRUE : FALSE;
        } else {
            throw new Exception("Erro: Valor incorreto indicado como indice de array do calendário: ".$indexLoop);
        }
    }

   /**
    * Link para mês anterior
    * @return String
    */
    private function getLinkMesAnterior()
    {
        $data = explode("/", date("m/Y", strtotime("-1 month", mktime(0, 0, 0, $this->getMes(), 1, $this->getAno()))));
        return "?m={$data[0]}&a={$data[1]}";
    }

   /**
    * Link para mês seguinte
    * @return String
    */
    private function getLinkMesSeguinte()
    {
        $data = explode("/", date("m/Y", strtotime("+1 month", mktime(0, 0, 0, $this->getMes(), 1, $this->getAno()))));
        return "?m={$data[0]}&a={$data[1]}";
    }

   /**
    * Link para ano anterior
    * @return String
    */
    private function getLinkAnoAnterior()
    {
        $data = explode("/", date("m/Y", strtotime("-1 year", mktime(0, 0, 0, $this->getMes(), 1, $this->getAno()))));
        return "?m={$data[0]}&a={$data[1]}";
    }

   /**
    * Link para ano seguinte
    * @return String
    */
    private function getLinkAnoSeguinte()
    {
        $data = explode("/", date("m/Y", strtotime("+1 year", mktime(0, 0, 0, $this->getMes(), 1, $this->getAno()))));
        return "?m={$data[0]}&a={$data[1]}";
    }

   /**
    * Retorna String html do Calendário
    * @return string Calendário HTML
    */
    public function getCalendario()
    {
        $str = "<table border=\"1\">\n\r";
        $str .= "\t<tr>\n\r\t\t<td colspan=\"7\"><center>\n\r";
        $str .= "\t\t<a href=\"{$this->getLinkMesAnterior()}\"><</a> {$this->getNomeMes()} ";
        $str .= "<a href=\"{$this->getLinkMesSeguinte()}\">></a> ";
        $str .= "de <a href=\"{$this->getLinkAnoAnterior()}\"><</a> {$this->getAno()} ";
        $str .= "<a href=\"{$this->getLinkAnoSeguinte()}\">></a> \n\r\t\t</center></td>\n\r\t<tr>\n\r";
        for ($index = 0; $index <= 6; $index++) {
            $str .= "\t\t<th>{$this->getSiglaPorDia($index)}</th>\n\r";
        }
        for ($index = 0; $index <= 41; $index++) {
            // Cor da célula
            $cor = ($index % 7 == 0)? "#D3D3D3" : "#F5F5F5";
            if ($index % 7 == 0) $str .= "\t</tr><tr>\n\r";
                if ($this->isAnterior($index)) {
                    $str .= "\t\t<td bgcolor=\"{$cor}\"><i>{$this->getDiasDoMes()[$index]}</i></td>\n\r";
                } else if ($this->isSeguinte($index)) {
                    $str .= "\t\t<td bgcolor=\"{$cor}\"><i>{$this->getDiasDoMes()[$index]}</i></td>\n\r";
                } else {
                    $dia = $this->getDiasDoMes()[$index];
                    $str .= "\t\t<td bgcolor=\"{$cor}\"><a href=\"?d={$dia}&m={$this->getMes()}&a={$this->getAno()}\">{$dia}</a></td>\n\r";
                }
            }
            $str .= "\t<tr>\n\r\t</table>\n\r";
            return $str;
        }
    
    }
}